Index: font-lock.el
===================================================================
RCS file: /pack/xemacscvs/XEmacs/xemacs/lisp/font-lock.el,v
retrieving revision 1.29
diff -u -r1.29 font-lock.el
--- lisp/font-lock.el	2005/01/26 04:18:15	1.29
+++ lisp/font-lock.el	2005/02/10 02:41:21
@@ -2311,159 +3397,275 @@
    ;; This is faster but not by much.  I don't see why not.
    ;(list (concat "^\\(" ctoken "\\)[ \t]*(") 1 'font-lock-function-name-face)
    ;;
-   ;; Added next two; they're both jolly-good fastmatch candidates so
-   ;; should be fast. --ben
+   ;; [[ Added next two; they're both jolly-good fastmatch candidates so
+   ;; should be fast. --ben ]]
    ;;
-   ;; Fontify structure names (in structure definition form).
-   (list (concat "^\\(typedef[ \t]+struct\\|struct\\|static[ \t]+struct\\)"
-      	   "[ \t]+\\(" ctoken "\\)[ \t]*\\(\{\\|$\\)")
-         2 'font-lock-function-name-face)
+   ;; Matchers for these are down below in ...-keywords-2.  Move them up
+   ;; if we want them here. --ben
    ;;
-   ;; Fontify case clauses.  This is fast because its anchored on the left.
-   '("case[ \t]+\\(\\(\\sw\\|\\s_\\)+\\)[ \t]+:". 1)
+;    ;; Fontify structure names (in structure definition form).
+;    (list (concat "^\\(typedef[ \t]+struct\\|struct\\|static[ \t]+struct\\)"
+;       	   "[ \t]+\\(" ctoken "\\)[ \t]*\\(\{\\|$\\)")
+;          2 'font-lock-function-name-face)
+;    ;;
+;    ;; Fontify case clauses.  This is fast because it's anchored on the left.
+;    '("case[ \t]+\\(\\(\\sw\\|\\s_\\)+\\)[ \t]+:". 1)
+;    ;;
+;    '("\\<\\(default\\):". 1)
+;    ;;
+   ;; Fontify error directives.
+   '("^#[ \t]*error[ \t]+\\(.+\\)" 1 font-lock-warning-face prepend)
    ;;
-   '("\\<\\(default\\):". 1)
    ;; Fontify filenames in #include <...> preprocessor directives as strings.
-   '("^#[ \t]*include[ \t]+\\(<[^>\"\n]+>\\)" 1 font-lock-string-face)
+   '("^#[ \t]*\\(import\\|include\\)[ \t]*\\(<[^>\"\n]*>?\\)"
+     2 font-lock-string-face)
    ;;
    ;; Fontify function macro names.
+;FSF'("^#[ \t]*define[ \t]+\\(\\sw+\\)(" 1 font-lock-function-name-face)
+   ;; #### Is this really any different?
    '("^#[ \t]*define[ \t]+\\(\\(\\sw+\\)(\\)" 2 font-lock-function-name-face)
-   ;;
-   ;; Fontify symbol names in #if ... defined preprocessor directives.
-   '("^#[ \t]*if\\>"
-     ("\\<\\(defined\\)\\>[ \t]*(?\\(\\sw+\\)?" nil nil
-      (1 font-lock-preprocessor-face) (2 font-lock-variable-name-face nil t)))
    ;;
-   ;; Fontify symbol names in #elif ... defined preprocessor directives.
-   '("^#[ \t]*elif\\>"
+   ;; Fontify symbol names in #elif or #if ... defined preprocessor directives.
+   '("^#[ \t]*\\(elif\\|if\\)\\>"
      ("\\<\\(defined\\)\\>[ \t]*(?\\(\\sw+\\)?" nil nil
+;FSF  (1 font-lock-builtin-face) (2 font-lock-variable-name-face nil t)))
       (1 font-lock-preprocessor-face) (2 font-lock-variable-name-face nil t)))
    ;;
    ;; Fontify otherwise as symbol names, and the preprocessor directive names.
-   '("^\\(#[ \t]*[a-z]+\\)\\>[ \t]*\\(\\sw+\\)?"
-     (1 font-lock-preprocessor-face) (2 font-lock-variable-name-face nil t))
-   ))
+   (list
+;FSF(concat "^#[ \t]*\\(" c-preprocessor-directives
+    (concat "^\\(#[ \t]*" c-preprocessor-directives
+	    "\\)\\>[ \t!]*\\(\\sw+\\)?")
+;FSF'(1 font-lock-builtin-face)
+    '(1 font-lock-preprocessor-face)
+    (list (+ 2 c-preprocessor-directives-depth)
+	  'font-lock-variable-name-face nil t))))
 
- (let ((cflk2-part-1
-	(list
-	 ;;
-	 ;; Simple regexps for speed.
-	 ;;
-	 ;; Fontify all type specifiers.
-	 (cons (concat "\\<\\(" c-type-types "\\)\\>") 'font-lock-type-face)))
-       (cflk2-part-2
-	(list
-	 ;; Fontify all builtin keywords (except case, default and goto;
-	 ;; see below).
-	 (cons (concat "\\<\\(" c-keywords "\\)\\>") 'font-lock-keyword-face)
-	 ;;
-	 ;; Fontify case/goto keywords and targets, and case default/goto tags.
-	 '("\\<\\(case\\|goto\\)\\>[ \t]*\\([^ \t\n:;]+\\)?"
-	   (1 font-lock-keyword-face) (2 font-lock-reference-face nil t))
-	 '("^[ \t]*\\(\\sw+\\)[ \t]*:" 1 font-lock-reference-face)))
-       (cflk3-part-1
-	;;
-	;; More complicated regexps for more complete highlighting for
-	;; types.  We still have to fontify type specifiers individually,
-	;; as C is so hairy.
-	(list
-	 ;;
-	 ;; Fontify all storage classes and type specifiers, plus their items.
-	 (list (concat "\\<\\(" c-type-types "\\)\\>"
-		       "\\([ \t*&]+\\sw+\\>\\)*")
-	       ;; Fontify each declaration item.
-	       '(font-lock-match-c++-style-declaration-item-and-skip-to-next
-		 ;; Start with point after all type specifiers.
-		 (goto-char (or (match-beginning 8) (match-end 1)))
-		 ;; Finish with point after first type specifier.
-		 (goto-char (match-end 1))
-		 ;; Fontify as a variable or function name.
-		 (1 (if (match-beginning 4)
-			font-lock-function-name-face
-		      font-lock-variable-name-face))))))
-       (cflk3-part-2
-	(list
-	 ;;
-	 ;; Fontify structures, or typedef names, plus their items.
-	 '("\\(}\\)[ \t*]*\\sw"
-	   (font-lock-match-c++-style-declaration-item-and-skip-to-next
-	    (goto-char (match-end 1)) nil
-	    (1 (if (match-beginning 4)
-		   font-lock-function-name-face
-		 font-lock-variable-name-face))))
-	 ;;
-	 ;; Fontify anything at beginning of line as a declaration or
-	 ;; definition.
-	 '("^\\(\\sw+\\)\\>\\([ \t*]+\\sw+\\>\\)*"
-	   (1 font-lock-type-face)
-	   (font-lock-match-c++-style-declaration-item-and-skip-to-next
-	    (goto-char (or (match-beginning 2) (match-end 1))) nil
-	    (1 (if (match-beginning 4)
-		   font-lock-function-name-face
-		 font-lock-variable-name-face))))))
-       (xcflk2-part-1
-	(list
-	 ;; Fontify all simple type specifiers used in XEmacs code.
-	 (cons (concat "\\<\\(" xemacs-c-type-types "\\)\\>")
-	       'font-lock-type-face)))
-       (xcflk3-part-1
-	;;
-	;; More complicated regexps for more complete highlighting for
-	;; types.  We still have to fontify type specifiers individually,
-	;; as C is so hairy.
-	(list
-	 ;;
-	 ;; Fontify all storage classes and type specifiers, plus their items.
-	 (list (concat "\\<\\(" xemacs-c-type-types "\\)\\>"
-		       "\\([ \t*&]+\\sw+\\>\\)*")
-	       ;; Fontify each declaration item.
-	       '(font-lock-match-c++-style-declaration-item-and-skip-to-next
-		 ;; Start with point after all type specifiers.
-		 (goto-char (or (match-beginning 8) (match-end 1)))
-		 ;; Finish with point after first type specifier.
-		 (goto-char (match-end 1))
-		 ;; Fontify as a variable or function name.
-		 (1 (if (match-beginning 4)
-			font-lock-function-name-face
-		      font-lock-variable-name-face)))))))
-
-   (setq c-font-lock-keywords-2
-	 (append c-font-lock-keywords-1
-		 cflk2-part-1
-		 cflk2-part-2))
-
-   (setq c-font-lock-keywords-3
-	 (append c-font-lock-keywords-2
-		 cflk3-part-1
-		 cflk3-part-2))
-
-   (setq xemacs-c-font-lock-keywords-2
-	 (append c-font-lock-keywords-1
-		 cflk2-part-1
-		 xcflk2-part-1
-		 cflk2-part-2))
-
-   (setq xemacs-c-font-lock-keywords-3
-	 (append xemacs-c-font-lock-keywords-2
-		 cflk3-part-1
-		 xcflk3-part-1
-		 cflk3-part-2)))
+ (setq c-font-lock-keywords-2
+  (append c-font-lock-keywords-1
+   (list
+    ;;
+    ;; Simple regexps for speed.
+    ;;
+    ;; Fontify all type names.
+    `(eval .
+      (cons (concat "\\<\\(" ,c-type-names "\\)\\>") 'font-lock-type-face))
+    ;;
+    ;; Fontify all builtin keywords (except case, default and goto; see below).
+    (concat "\\<\\(" c-keywords "\\|" c-type-specs "\\)\\>")
+    ;;
+    ;; Fontify case/goto keywords and targets, and case default/goto tags.
+    '("\\<\\(case\\|goto\\)\\>"
+      (1 font-lock-keyword-face)
+      ("\\(-[0-9]+\\|\\sw+\\)"
+       ;; Return limit of search.
+       (save-excursion (skip-chars-forward "^:\n") (point))
+       nil
+       (1 font-lock-constant-face nil t)))
+    ;; Anders Lindgren <andersl@andersl.com> points out that it is quicker to
+    ;; use MATCH-ANCHORED to effectively anchor the regexp on the left.
+    ;; This must come after the one for keywords and targets.
+    '(":" ("^[ \t]*\\(\\sw+\\)[ \t]*:[ \t]*$"
+	   (beginning-of-line) (end-of-line)
+	   (1 font-lock-constant-face)))
+    )))
+
+ (setq c-font-lock-keywords-3
+  (append c-font-lock-keywords-2
+   ;;
+   ;; More complicated regexps for more complete highlighting for types.
+   ;; We still have to fontify type specifiers individually, as C is so hairy.
+   (list
+    ;;
+    ;; Fontify all storage types, plus their items.
+    `(eval .
+      (list (concat "\\<\\(" ,c-type-names "\\)\\>"
+		    "\\([ \t*&]+\\sw+\\>\\)*")
+	    ;; Fontify each declaration item.
+	    (list 'font-lock-match-c-style-declaration-item-and-skip-to-next
+		  ;; Start with point after all type specifiers.
+		  (list 'goto-char (list 'or
+					 (list 'match-beginning
+					       (+ ,c-type-names-depth 2))
+					 '(match-end 1)))
+		  ;; Finish with point after first type specifier.
+		  '(goto-char (match-end 1))
+		  ;; Fontify as a variable or function name.
+		  '(1 (if (match-beginning 2)
+			  font-lock-function-name-face
+			font-lock-variable-name-face)))))
+    ;;
+    ;; Fontify all storage specs and types, plus their items.
+    `(eval .
+      (list (concat "\\<\\(" ,c-type-specs "\\)\\>"
+		    "[ \t]*\\(\\sw+\\)?")
+	  (list 1 'font-lock-keyword-face)
+	  (list ,(+ c-type-specs-depth 2) 'font-lock-type-face nil t)
+	  (list 'font-lock-match-c-style-declaration-item-and-skip-to-next
+		  nil 
+		  ;; Finish with point after the variable name if
+		  ;; there is one.
+		  `(if (match-end 2) 
+		       (goto-char (match-end 2)))
+		  ;; Fontify as a variable or function name.
+		  '(1 (if (match-beginning 2)
+			  font-lock-function-name-face
+			font-lock-variable-name-face) nil t))))
+    ;;
+    ;; Fontify structures, or typedef names, plus their items.
+    '("\\(}\\)[ \t*]*\\sw"
+      (font-lock-match-c-style-declaration-item-and-skip-to-next
+       (goto-char (match-end 1)) nil
+       (1 font-lock-type-face)))
+    ;;
+    ;; Fontify anything at beginning of line as a declaration or definition.
+    '("^\\(\\sw+\\)\\>\\([ \t*]+\\sw+\\>\\)*"
+      (1 font-lock-type-face)
+      (font-lock-match-c-style-declaration-item-and-skip-to-next
+       (goto-char (or (match-beginning 2) (match-end 1))) nil
+       (1 (if (match-beginning 2)
+	      font-lock-function-name-face
+	    font-lock-variable-name-face))))
+    )))
+ )
+
+(defvar c-font-lock-keywords c-font-lock-keywords-1
+  "Default expressions to highlight in C mode.
+See also `c-font-lock-extra-types'.")
+
+;;; C++.
+
+(defconst c++-font-lock-keywords-1 nil
+  "Subdued level highlighting for C++ modes.")
+
+(defconst c++-font-lock-keywords-2 nil
+  "Medium level highlighting for C++ modes.")
+
+(defconst c++-font-lock-keywords-3 nil
+  "Gaudy level highlighting for C++ modes.")
+
+(defun font-lock-match-c++-style-declaration-item-and-skip-to-next (limit)
+  ;; Match, and move over, any declaration/definition item after point.
+  ;; The expect syntax of an item is "word" or "word::word", possibly ending
+  ;; with optional whitespace and a "(".  Everything following the item (but
+  ;; belonging to it) is expected to by skip-able by `forward-sexp', and items
+  ;; are expected to be separated with a "," or ";".
+  (if (looking-at "[ \t*&]*\\(\\(?:\\sw\\|\\s_\\)+\\)\\(::\\(\\(?:\\sw\\|\\s_\\)+\\)\\)?[ \t]*\\((\\)?")
+      (save-match-data
+	(condition-case nil
+	    (save-restriction
+	      ;; Restrict to the end of line, currently guaranteed to be LIMIT.
+	      (narrow-to-region (point-min) limit)
+	      (goto-char (match-end 1))
+	      ;; Move over any item value, etc., to the next item.
+	      (while (not (looking-at "[ \t]*\\([,;]\\|$\\)"))
+		(goto-char (or (scan-sexps (point) 1) (point-max))))
+	      (goto-char (match-end 0)))
+	  (error t)))))
+
+(defun font-lock-match-c++-structor-declaration (limit)
+  ;; Match C++ constructors and destructors inside class declarations.
+  (let ((res nil)
+	(regexp (concat "^\\s-+\\(\\(virtual\\|explicit\\)\\s-+\\)*~?\\(\\<"
+			(mapconcat 'identity
+				   c++-font-lock-extra-types "\\|")
+			"\\>\\)\\s-*("
+			;; Don't match function pointer declarations, e.g.:
+			;;    Foo (*fptr)();
+			"\\s-*[^*( \t]")))
+    (while (progn (setq res (re-search-forward regexp limit t))
+		  (and res
+		       (save-excursion
+			 (beginning-of-line)
+			 (save-match-data
+			   (not (vectorp (c-at-toplevel-p))))))))
+    res))
+
+(let* ((c++-keywords
+	(eval-when-compile
+	  (regexp-opt
+	   '("break" "continue" "do" "else" "for" "if" "return" "switch"
+	     "while" "asm" "catch" "delete" "new" "sizeof" "this" "throw" "try"
+	     "typeid"
+	     ;; XEmacs:
+	     "false" "true"
+	     ;; Branko Cibej <branko.cibej@hermes.si> says this is new.
+	     "export"
+	     ;; Mark Mitchell <mmitchell@usa.net> says these are new.
+	     "mutable" "explicit"
+	     ;; Alain Picard <ap@abelard.apana.org.au> suggests treating these
+	     ;; as keywords not types.
+	     "typedef" "template"
+	     "extern" "auto" "register" "const" "volatile" "static"
+	     "inline" "friend" "virtual"
+	     ;; Standard C++ operator names.
+	     "and" "and_eq" "bitand" "bitor" "compl" "not" "not_eq"
+	     "or" "or_eq" "xor" "xor_eq"))))
+       (c++-operators
+	(eval-when-compile
+	  (regexp-opt
+	   ;; Taken from Stroustrup, minus keywords otherwise fontified.
+	   '("+" "-" "*" "/" "%" "^" "&" "|" "~" "!" "=" "<" ">" "+=" "-="
+	     "*=" "/=" "%=" "^=" "&=" "|=" "<<" ">>" ">>=" "<<=" "==" "!="
+	     "<=" ">=" "&&" "||" "++" "--" "->*" "," "->" "[]" "()"))))
+       (c++-type-specs
+	(eval-when-compile
+	  (regexp-opt
+	   '("class" "public" "private" "protected" "typename"
+	     "struct" "union" "enum" "namespace" "using"
+	     ;; Eric Hopper <hopper@omnifarious.mn.org> says these are new.
+	     "static_cast" "dynamic_cast" "const_cast" "reinterpret_cast"
+	     ;; XEmacs:
+	     "wchar_t"
+	     ) t)))
+       (c++-type-specs-depth
+	(regexp-opt-depth c++-type-specs))
+       (c++-type-names
+	`(mapconcat 'identity
+	  (cons
+	   ,(eval-when-compile
+	      (regexp-opt
+	       '("signed" "unsigned" "short" "long"
+		 "int" "char" "float" "double" "void"
+		 "bool" "complex")))
+	   c++-font-lock-extra-types)
+	  "\\|"))
+       (c++-type-names-depth `(regexp-opt-depth ,c++-type-names))
+       ;;
+       ;; A brave attempt to match templates following a type and/or match
+       ;; class membership.  See and sync the above function
+       ;; `font-lock-match-c++-style-declaration-item-and-skip-to-next'.
+       (c++-type-suffix (concat "\\([ \t]*<\\([^>\n]+\\)[ \t*&]*>\\)?"
+				"\\([ \t]*::[ \t*~]*\\(\\sw+\\)\\)*"))
+       (c++-type-suffix-depth (regexp-opt-depth c++-type-suffix))
+       ;; If the string is a type, it may be followed by the cruft above.
+       (c++-type-spec (concat "\\(\\sw+\\)\\>" c++-type-suffix))
+       ;FSF 21.2 (unused) (c++-type-spec-depth (regexp-opt-depth c++-type-spec))
+       ;;
+       ;; Parenthesis depth of user-defined types not forgetting their cruft.
+       (c++-type-depth `(regexp-opt-depth
+			 (concat ,c++-type-names ,c++-type-suffix)))
+       )
 
  (setq c++-font-lock-keywords-1
   (append
    ;;
    ;; The list `c-font-lock-keywords-1' less that for function names.
-   ;; the simple function form regexp has been removed. --dmoore
-   ;;(cdr c-font-lock-keywords-1)
+;FSF(cdr c-font-lock-keywords-1)
+   ;; XEmacs: the simple function form regexp has been removed. --dmoore
    c-font-lock-keywords-1
    ;;
-   ;; Fontify function name definitions, possibly incorporating class name.
    (list
-    '("^\\(\\sw+\\)\\(::\\(\\sw+\\)\\)?[ \t]*("
-      (1 (if (match-beginning 2)
-	     font-lock-type-face
-	   font-lock-function-name-face))
-      (3 (if (match-beginning 2) font-lock-function-name-face) nil t))
+    ;;
+    ;; Fontify function name definitions, possibly incorporating class names.
+    (list (concat "^" c++-type-spec "[ \t]*(")
+	  '(1 (if (or (match-beginning 2) (match-beginning 4))
+		  font-lock-type-face
+		font-lock-function-name-face))
+	  '(3 font-lock-type-face nil t)
+;FSF	  '(5 font-lock-function-name-face nil t))
+	  '(5 (if (or (match-beginning 2) (match-beginning 4))
+		  font-lock-function-name-face) nil t))
     )))
 
  (setq c++-font-lock-keywords-2
@@ -2471,19 +3673,40 @@
    (list
     ;;
     ;; The list `c-font-lock-keywords-2' for C++ plus operator overloading.
-    (cons (concat "\\<\\(" c++-type-types "\\)\\>") 'font-lock-type-face)
+    `(eval .
+      (cons (concat "\\<\\(" ,c++-type-names "\\)\\>")
+	    'font-lock-type-face))
     ;;
-    ;; Fontify operator function name overloading.
-    '("\\<\\(operator\\)\\>[ \t]*\\([][)(><!=+-][][)(><!=+-]?\\)?"
-      (1 font-lock-keyword-face) (2 font-lock-function-name-face nil t))
+    ;; Fontify operator overloading.
+    (list (concat "\\<\\(operator\\)\\>[ \t]*\\(" c++-operators "\\)?")
+	  '(1 font-lock-keyword-face)
+	  '(2 font-lock-builtin-face nil t))
     ;;
     ;; Fontify case/goto keywords and targets, and case default/goto tags.
-    '("\\<\\(case\\|goto\\)\\>[ \t]*\\([^ \t\n:;]+\\)?"
-      (1 font-lock-keyword-face) (2 font-lock-reference-face nil t))
-    '("^[ \t]*\\(\\sw+\\)[ \t]*:[^:]" 1 font-lock-reference-face)
+    '("\\<\\(case\\|goto\\)\\>"
+      (1 font-lock-keyword-face)
+      ("\\(-[0-9]+\\|\\sw+\\)[ \t]*\\(::\\)?"
+       ;; Return limit of search.
+       (save-excursion
+	 (while (progn
+		  (skip-chars-forward "^:\n")
+		  (looking-at "::"))
+	   (forward-char 2))
+	 (point))
+       nil
+       (1 (if (match-beginning 2)
+	      font-lock-type-face
+	    font-lock-constant-face) nil t)))
+    ;; This must come after the one for keywords and targets.
+    '(":" ("^[ \t]*\\(\\sw+\\)[ \t]*:\\($\\|[^:]\\)"
+	   (beginning-of-line) (end-of-line)
+	   (1 font-lock-constant-face)))
     ;;
     ;; Fontify other builtin keywords.
-    (cons (concat "\\<\\(" c++-keywords "\\)\\>") 'font-lock-keyword-face)
+    (concat "\\<\\(" c++-keywords "\\|" c++-type-specs "\\)\\>")
+    ;;
+    ;; Eric Hopper <hopper@omnifarious.mn.org> says `true' and `false' are new.
+    '("\\<\\(false\\|true\\)\\>" . font-lock-constant-face)
     )))
 
  (setq c++-font-lock-keywords-3
@@ -2493,49 +3716,248 @@
    (list
     ;;
     ;; Fontify all storage classes and type specifiers, plus their items.
-    (list (concat "\\<\\(" c++-type-types "\\)\\>"
-		  "\\([ \t*&]+\\sw+\\>\\)*")
-	  ;; Fontify each declaration item.
+    `(eval .
+      (list (concat "\\<\\(" ,c++-type-names "\\)\\>" ,c++-type-suffix
+		    "\\([ \t*&]+" ,c++-type-spec "\\)*")
+	    ;; The name of any template type.
+	    (list (+ ,c++-type-names-depth 3) 'font-lock-type-face nil t)
+	    ;; Fontify each declaration item.
+	    (list 'font-lock-match-c++-style-declaration-item-and-skip-to-next
+		  ;; Start with point after all type specifiers.
+		  (list 'goto-char (list 'or (list 'match-beginning
+						   (+ ,c++-type-depth 2))
+					 '(match-end 1)))
+		  ;; Finish with point after first type specifier.
+		  '(goto-char (match-end 1))
+		  ;; Fontify as a variable or function name.
+		  '(1 (cond ((or (match-beginning 2) (match-beginning 4))
+			     font-lock-type-face)
+			    ((and (match-beginning 6) (c-at-toplevel-p))
+			     font-lock-function-name-face)
+			    (t
+			     font-lock-variable-name-face)))
+		  '(3 font-lock-type-face nil t)
+		  '(5 (if (match-beginning 6)
+			  font-lock-function-name-face
+			font-lock-variable-name-face) nil t))))
+    ;;
+    ;; Fontify all storage specs and types, plus their items.
+    `(eval .
+      (list (concat "\\<" ,c++-type-specs "\\>" ,c++-type-suffix
+		    "[ \t]*\\(" ,c++-type-spec "\\)?")
+	    ;; The name of any template type.
+	    (list ,(+ c++-type-specs-depth 2) 'font-lock-type-face nil t)
+	    ;; The name of any type.
+	    (list (+ ,c++-type-specs-depth ,c++-type-suffix-depth 2)
+		  'font-lock-type-face nil t)
+	    ;; Fontify each declaration item.
+	    (list 'font-lock-match-c++-style-declaration-item-and-skip-to-next
+		  ;; Start with point after all type specifiers.
+		  nil
+		  ;; Finish with point after first type specifier.
+		  nil
+		  ;; Fontify as a variable or function name.
+		  '(1 (cond ((or (match-beginning 2) (match-beginning 4))
+			     font-lock-type-face)
+			    ((and (match-beginning 6) (c-at-toplevel-p))
+			     font-lock-function-name-face)
+			    (t
+			     font-lock-variable-name-face)))
+		  '(3 font-lock-type-face nil t)
+		  '(5 (if (match-beginning 6)
+			  font-lock-function-name-face
+			font-lock-variable-name-face) nil t))
+	    ))
+    ;;
+    ;; Fontify structures, or typedef names, plus their items.
+    '("\\(}\\)[ \t*]*\\sw"
+      (font-lock-match-c++-style-declaration-item-and-skip-to-next
+       (goto-char (match-end 1)) nil
+       (1 font-lock-type-face)))
+    ;;
+    ;; Fontify anything at beginning of line as a declaration or definition.
+    (list (concat "^\\(" c++-type-spec "[ \t*&]*\\)+")
 	  '(font-lock-match-c++-style-declaration-item-and-skip-to-next
-	    ;; Start with point after all type specifiers.
-	    (goto-char (or (match-beginning 13) (match-end 1)))
-	    ;; Finish with point after first type specifier.
+	    (goto-char (match-beginning 1))
 	    (goto-char (match-end 1))
-	    ;; Fontify as a variable or function name.
-	    (1 (cond ((match-beginning 2) 'font-lock-type-face)
-		     ((match-beginning 4) 'font-lock-function-name-face)
-		     (t 'font-lock-variable-name-face)))
-	    (3 (if (match-beginning 4)
-		   'font-lock-function-name-face
-		 'font-lock-variable-name-face) nil t)))
+	    (1 (cond ((or (match-beginning 2) (match-beginning 4))
+		      font-lock-type-face)
+		     ((match-beginning 6) font-lock-function-name-face)
+		     (t font-lock-variable-name-face)))
+	    (3 font-lock-type-face nil t)
+	    (5 (if (match-beginning 6)
+		   font-lock-function-name-face
+		 font-lock-variable-name-face) nil t)))
+    ;;
+    ;; Fontify constructors and destructors inside class declarations.
+    '(font-lock-match-c++-structor-declaration
+      (3 font-lock-function-name-face t))
+    )))
+ )
+
+(defvar c++-font-lock-keywords c++-font-lock-keywords-1
+  "Default expressions to highlight in C++ mode.
+See also `c++-font-lock-extra-types'.")
+
+;;; Objective-C.
+
+(defconst objc-font-lock-keywords-1 nil
+  "Subdued level highlighting for Objective-C mode.")
+
+(defconst objc-font-lock-keywords-2 nil
+  "Medium level highlighting for Objective-C mode.
+See also `objc-font-lock-extra-types'.")
+
+(defconst objc-font-lock-keywords-3 nil
+  "Gaudy level highlighting for Objective-C mode.
+See also `objc-font-lock-extra-types'.")
+
+;; Regexps written with help from Stephen Peters <speters@us.oracle.com> and
+;; Jacques Duthen Prestataire <duthen@cegelec-red.fr>.
+(let* ((objc-keywords
+	(eval-when-compile
+	  (regexp-opt '("break" "continue" "do" "else" "for" "if" "return"
+			"switch" "while" "sizeof" "self" "super"
+			"typedef" "auto" "extern" "static"
+			"volatile" "const"))))
+       (objc-type-specs
+	(eval-when-compile
+	  (regexp-opt
+	   '("register" "struct" "union" "enum"
+	     "oneway" "in" "out" "inout" "bycopy" "byref") t)))
+       (objc-type-specs-depth
+	(regexp-opt-depth objc-type-specs))
+       (objc-type-names
+	`(mapconcat 'identity
+	  (cons
+	   ,(eval-when-compile
+	      (regexp-opt
+	       '("signed" "unsigned" "short" "long"
+		 "int" "char" "float" "double" "void"
+		 "id")))
+	   objc-font-lock-extra-types)
+	  "\\|"))
+       (objc-type-names-depth
+	`(regexp-opt-depth ,objc-type-names))
+       )
+ (setq objc-font-lock-keywords-1
+  (append
+   ;;
+   ;; The list `c-font-lock-keywords-1' less that for function names.
+   (cdr c-font-lock-keywords-1)
+   (list
+    ;;
+    ;; Fontify compiler directives.
+    '("@\\(\\sw+\\)\\>"
+      (1 font-lock-keyword-face)
+      ("\\=[ \t:<,]*\\(\\sw+\\)" nil nil
+       (1 font-lock-type-face)))
+    ;;
+    ;; Fontify method names and arguments.  Oh Lordy!
+    ;; First, on the same line as the function declaration.
+    '("^[+-][ \t]*\\(PRIVATE\\>\\)?[ \t]*\\(([^)\n]+)\\)?[ \t]*\\(\\sw+\\)"
+      (1 font-lock-keyword-face nil t)
+      (3 font-lock-function-name-face)
+      ("\\=[ \t]*\\(\\sw+\\)?:[ \t]*\\(([^)\n]+)\\)?[ \t]*\\(\\sw+\\)"
+       nil nil
+       (1 font-lock-function-name-face nil t)
+       (3 font-lock-variable-name-face)))
+    ;; Second, on lines following the function declaration.
+    '(":" ("^[ \t]*\\(\\sw+\\)?:[ \t]*\\(([^)\n]+)\\)?[ \t]*\\(\\sw+\\)"
+	   (beginning-of-line) (end-of-line)
+	   (1 font-lock-function-name-face nil t)
+	   (3 font-lock-variable-name-face)))
+    )))
+
+ (setq objc-font-lock-keywords-2
+  (append objc-font-lock-keywords-1
+   (list
+    ;;
+    ;; Simple regexps for speed.
+    ;;
+    ;; Fontify all type specifiers.
+    `(eval .
+      (cons (concat "\\<\\(" ,objc-type-names "\\)\\>")
+	    'font-lock-type-face))
+    ;;
+    ;; Fontify all builtin keywords (except case, default and goto; see below).
+    (concat "\\<\\(" objc-keywords "\\|" objc-type-specs "\\)\\>")
+    ;;
+    ;; Fontify case/goto keywords and targets, and case default/goto tags.
+    '("\\<\\(case\\|goto\\)\\>[ \t]*\\(-?\\sw+\\)?"
+      (1 font-lock-keyword-face) (2 font-lock-constant-face nil t))
+    ;; Fontify tags iff sole statement on line, otherwise we detect selectors.
+    ;; This must come after the one for keywords and targets.
+    '(":" ("^[ \t]*\\(\\sw+\\)[ \t]*:[ \t]*$"
+	   (beginning-of-line) (end-of-line)
+	   (1 font-lock-constant-face)))
+    ;;
+    ;; Fontify null object pointers.
+    '("\\<[Nn]il\\>" . font-lock-constant-face)
+    )))
+
+ (setq objc-font-lock-keywords-3
+  (append objc-font-lock-keywords-2
+   ;;
+   ;; More complicated regexps for more complete highlighting for types.
+   ;; We still have to fontify type specifiers individually, as C is so hairy.
+   (list
+    ;;
+    ;; Fontify all storage classes and type specifiers, plus their items.
+    `(eval .
+      (list (concat "\\<\\(" ,objc-type-names "\\)\\>"
+		    "\\([ \t*&]+\\sw+\\>\\)*")
+	    ;; Fontify each declaration item.
+	    (list 'font-lock-match-c-style-declaration-item-and-skip-to-next
+		  ;; Start with point after all type specifiers.
+		  (list 'goto-char
+			(list 'or (list 'match-beginning
+					(+ ,objc-type-names-depth 2))
+			      '(match-end 1)))
+		  ;; Finish with point after first type specifier.
+		  '(goto-char (match-end 1))
+		  ;; Fontify as a variable or function name.
+		  '(1 (if (match-beginning 2)
+			  font-lock-function-name-face
+			font-lock-variable-name-face)))))
+    ;;
+    ;; Fontify all storage specs and types, plus their items.
+    `(eval .
+      (list (concat "\\<\\(" ,objc-type-specs "[ \t]*\\)+\\>"
+		    "[ \t]*\\(\\sw+\\)?")
+	    ;; The name of any type.
+	    (list ,(+ objc-type-specs-depth 2) 'font-lock-type-face nil t)
+	    ;; Fontify each declaration item.
+	    (list 'font-lock-match-c++-style-declaration-item-and-skip-to-next
+		  nil nil
+		  ;; Fontify as a variable or function name.
+		  '(1 (if (match-beginning 2)
+			  font-lock-function-name-face
+			font-lock-variable-name-face)))
+	    ))
     ;;
     ;; Fontify structures, or typedef names, plus their items.
     '("\\(}\\)[ \t*]*\\sw"
-      (font-lock-match-c++-style-declaration-item-and-skip-to-next
+      (font-lock-match-c-style-declaration-item-and-skip-to-next
        (goto-char (match-end 1)) nil
-       (1 (if (match-beginning 4)
-	      font-lock-function-name-face
-	    font-lock-variable-name-face))))
+       (1 font-lock-type-face)))
     ;;
     ;; Fontify anything at beginning of line as a declaration or definition.
     '("^\\(\\sw+\\)\\>\\([ \t*]+\\sw+\\>\\)*"
       (1 font-lock-type-face)
-      (font-lock-match-c++-style-declaration-item-and-skip-to-next
+      (font-lock-match-c-style-declaration-item-and-skip-to-next
        (goto-char (or (match-beginning 2) (match-end 1))) nil
-       (1 (cond ((match-beginning 2) 'font-lock-type-face)
-		((match-beginning 4) 'font-lock-function-name-face)
-		(t 'font-lock-variable-name-face)))
-       (3 (if (match-beginning 4)
-	      'font-lock-function-name-face
-	    'font-lock-variable-name-face) nil t)))
+       (1 (if (match-beginning 2)
+	      font-lock-function-name-face
+	    font-lock-variable-name-face))))
     )))
  )
 
-(defvar c-font-lock-keywords c-font-lock-keywords-1
-  "Default expressions to highlight in C mode.")
+(defvar objc-font-lock-keywords objc-font-lock-keywords-1
+  "Default expressions to highlight in Objective-C mode.
+See also `objc-font-lock-extra-types'.")
 
-(defvar c++-font-lock-keywords c++-font-lock-keywords-1
-  "Default expressions to highlight in C++ mode.")
+;; END SYNCHED WITH FSF 21.2.
 
 ;;; Java.
 
